<template>
  <section id="one-pokemon-page">
    <div class="top-screen">
      <div>
        <p>{{pokemon.hp ? pokemon.hp.toString().padStart(3, '0') : ''}}</p>
        <p>{{pokemon.hp ? pokemon.pointAttack.toString().padStart(3, '0') : ''}}</p>
        <p>{{pokemon.hp ? pokemon.pointDefense.toString().padStart(3, '0') : ''}}</p>
        <p>{{pokemon.hp ? pokemon.speed.toString().padStart(3, '0') : ''}}</p>
        <p>{{(pokemon.totalPoint - pokemon.pointAttack -pokemon.pointDefense - pokemon.speed) < 0 ? 'Err' : pokemon.totalPoint - pokemon.pointAttack -pokemon.pointDefense - pokemon.speed}}</p>
        <input
          v-if="isEditing"
          :value="pokemon.pointAttack"
          class="input is-small"
          type="number"
          placeholder="Attack"
          @change="pokemon.pointAttack = $event.target.value"
        />
        <input
          v-if="isEditing"
          :value="pokemon.pointDefense"
          class="input is-small"
          type="number"
          placeholder="Defense"
          @change="pokemon.pointDefense = $event.target.value"
        />
        <input
          v-if="isEditing"
          :value="pokemon.speed"
          class="input is-small"
          type="number"
          placeholder="Speed"
          @change="pokemon.speed = $event.target.value"
        />
      </div>
      <div>
        <p>{{pokemon.name}}</p>
        <p>100</p>
        <input
          v-if="isEditing"
          :value="pokemon.name"
          class="input is-small"
          type="text"
          placeholder="Name"
          @change="onChangeName($event)"
          maxlength="10"
        />

        <img
          :src="pokemon.numero && pokemon.numero < 650 ? require(`@/assets/pkmn/front/${pokemon.numero}.png`) : require(`@/assets/pkmn/front/substitute.png`)"
        />
      </div>
    </div>
    <div class="middle-screen"></div>

    <div class="bottom-screen">
      <div>
        <div class="atks">
          <div>
            <div>
              <img
                :src="capacity1.idTypePokemon.name ? require(`@/assets/type/${(capacity1.idTypePokemon.name).toLowerCase()}.png`) : null"
              />
              <p>{{capacity1.puissance}}💪 {{capacity1.precision}}🏹</p>
            </div>
            <div class="field">
              <div class="control">
                <div class="select is-small">
                  <select :disabled="!isEditing" v-model="selectedCapacity1">
                    <optgroup v-for="(capacities, key) in pokemonTypes" :label="key">
                      <option
                        v-for="capacity in capacities"
                        :key="capacity.id"
                        :value="capacity.id"
                        :selected="selectedCapacity1"
                      >{{ capacity.id }} - {{ capacity.name }}</option>
                    </optgroup>
                  </select>
                </div>
              </div>
            </div>
          </div>
          <div>
            <div>
              <img
                :src="capacity2.idTypePokemon.name ? require(`@/assets/type/${(capacity2.idTypePokemon.name).toLowerCase()}.png`) : null"
              />
              <p>{{capacity2.puissance}}💪 {{capacity2.precision}}🏹</p>
            </div>
            <div class="field">
              <div class="control">
                <div class="select is-small">
                  <select :disabled="!isEditing" v-model="selectedCapacity2">
                    <optgroup v-for="(capacities, name) in pokemonTypes" :label="name">
                      <option
                        v-for="capacity in capacities"
                        :key="capacity.id"
                        :value="capacity.id"
                        :selected="selectedCapacity2"
                      >{{ capacity.id }} - {{ capacity.name }}</option>
                    </optgroup>
                  </select>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <button class="button is-primary" @click="edit()">
        <span class="icon is-medium">
          <font-awesome-icon icon="edit" />
        </span>
        <span>{{isEditing ? 'Cancel' : 'Edit'}}</span>
      </button>

      <button
        class="button is-success"
        @click="save()"
        v-if="isEditing"
        :disabled="(pokemon.totalPoint - pokemon.pointAttack - pokemon.pointDefense - pokemon.speed) < 0"
      >
        <span class="icon is-medium">
          <font-awesome-icon icon="save" />
        </span>
        <span>Save</span>
      </button>

      <button class="button is-danger" @click="goback()">
        <span class="icon is-medium">
          <font-awesome-icon icon="backward" />
        </span>
        <span>Return</span>
      </button>
    </div>
  </section>
</template>

<script>
import router from "../router";

const baseCapacity = {
  idTypePokemon: { name: "normal" },
  puissance: null,
  precision: null
};

export default {
  name: "one-pokemon",
  data: function() {
    return {
      isEditing: false,
      pokemon: {},
      pokemonTypes: {},
      capacities: [],
      selectedCapacity1: "",
      capacity1: {
        idTypePokemon: { name: "normal" },
        puissance: null,
        precision: null
      },
      selectedCapacity2: "",
      capacity2: {
        idTypePokemon: { name: "normal" },
        puissance: null,
        precision: null
      }
    };
  },
  watch: {
    selectedCapacity1() {
      this.capacity1 = this.getCapacityBySelected(this.selectedCapacity1) || {
        ...baseCapacity
      };
    },
    selectedCapacity2() {
      this.capacity2 = this.getCapacityBySelected(this.selectedCapacity2) || {
        ...baseCapacity
      };
    }
  },
  mounted() {
    this.getPokemon();
    this.getAllCapacities();
  },
  methods: {
    getPokemon() {
      this.$pokemonService.getCustomPokemon(
        this.$route.params.id,
        res => {
          this.pokemon = res.data;
          this.selectedCapacity1 = res.data.idCapacity1.id;
          this.selectedCapacity2 = res.data.idCapacity2.id;
          this.getCapacities(res.data.idTypePokemon.id);
        },
        err => {
          console.log(err);
        }
      );
    },
    getCapacityBySelected(selectedId) {
      return this.capacities.find(({ id }) => id === selectedId);
    },
    getAllCapacities() {
      this.$capacityService.getAllCapacities(res => {
        this.capacities = res.data;
        this.capacity1 = this.getCapacityBySelected(this.selectedCapacity1) || {
          ...baseCapacity
        };
        this.capacity2 = this.getCapacityBySelected(this.selectedCapacity2) || {
          ...baseCapacity
        };
      });
    },
    getCapacities(pokemonTypeId) {
      if (pokemonTypeId !== 1) {
        this.$capacityService.getCapacitiesByType(
          pokemonTypeId,
          res1 => {
            let typeName = `${res1.data.name}`;
            this.pokemonTypes[typeName] = res1.data.capacities;
            this.$forceUpdate();
          },
          err => {
            console.log("normalCapacities error: " + err);
          }
        );
      }
      this.$capacityService.getCapacitiesByType(
        1,
        res => {
          this.pokemonTypes.Normal = res.data.capacities;
          this.$forceUpdate();
        },
        err => {
          console.log("normalCapacities error: " + err);
        }
      );
    },
    goback() {
      router.back();
    },
    onChangeName(event) {
      this.pokemon.name = event.target.value;
    },
    edit() {
      this.isEditing = !this.isEditing;
    },
    save() {
      console.log("saving...", this.$route?.params?.id);
      let body = {
        name: this.pokemon.name,
        hp: parseInt(this.pokemon.hp),
        pointAttack: parseInt(this.pokemon.pointAttack),
        pointDefense: parseInt(this.pokemon.pointDefense),
        speed: parseInt(this.pokemon.speed),
        idCapacity1: parseInt(this.selectedCapacity1),
        idCapacity2: parseInt(this.selectedCapacity2)
      };
      this.$pokemonService.updateCustomPokemon(
        this.$route.params.id,
        body,
        res => {
          router.back();
        },
        err => {
          console.log("Error on update");
        }
      );
    }
  },
  computed: {},
  components: {}
};
</script>


<style scoped lang="scss">
#one-pokemon-page {
  .top-screen {
    background-image: url("~@/assets/background-top-pokemon-info.png") !important;
    justify-content: space-between !important;
    flex-direction: row !important;
    font-family: PokemonGb;
    padding: 3.2em 4.5em 0 14.5em;
    > div {
      text-align: right;
      &:first-child {
        position: relative;
        > p {
          margin-bottom: 0.5em;
          &:nth-child(2) {
            margin-top: 1.5em;
          }
        }
        > input {
          position: absolute;
          z-index: 999;
          width: 132px;
          max-width: 132px;
          right: -6px;
          &:nth-child(6) {
            top: 45px;
          }
          &:nth-child(7) {
            top: 77px;
          }
          &:nth-child(8) {
            top: 110px;
          }
        }
      }
      &:last-child {
        width: 100%;
        position: relative;
        margin-top: 1em;
        > p {
          &:first-child {
            color: white;
            margin: 0 0px 0px 3em;
            text-align: left;
          }
          &:nth-child(2) {
            margin: 0.75em 0 0px 5em;
            text-align: left;
          }
        }
        > img {
          position: absolute;
          width: 180px;
          max-width: unset;
          left: 45px;
          top: 50px;
        }
        > input {
          position: absolute;
          z-index: 999;
          top: -3px;
          left: 3.2em;
          width: 192px;
          max-width: 374px;
        }
      }
    }
  }
  .bottom-screen {
    font-family: PokemonGb;
    justify-content: flex-start !important;
    background-image: url("~@/assets/background-bottom-pokemon-info.png") !important;
    > div {
      > div.atks {
        width: 240px;
        > div {
          > div {
            &:first-child {
              // display: block;
              height: 32px;
              display: flex;
              justify-content: flex-start;
              flex-direction: row;
              img {
                width: 50px;
                height: min-content;
                margin: 5px 5px;
              }
              p {
                font-size: 12px;
                line-height: 34px;
              }
            }

            &.field {
              margin-bottom: 2px !important;
              .select {
                width: 100%;
                select {
                  width: 100%;
                }
              }
            }
          }
        }
      }
    }
    > button {
      width: 120px !important;
      text-align: right;
      margin: 0em 2em 1em auto;
    }
  }
}
</style>
